<?php

 /**

  * Live Ratings Implementation

  * Base Class

  * @autor jose @ www.t1poder.com.ar - www.aocgroup.com.ar

  * @date Agoust, 2006

  **/



class CLiveRatings

{

	var $players;

	var $avgInfo;



	/**

	 * Constructor

	 **/

	function CLiveRatings ()

	{

		$this->players = array ();

		$this->avgInfo = array ();

	}

	/**

	 * Return the Average Info

	 * @return array $AvgInfo

	 **/

	function getAVGInfo ()

	{

		return $this->avgInfo;

	}



	/**

	 * Add Player used by readPlayersFromFile ()

	 * @param string $strNick Nick of the player

	 **/

	function addPlayers ($strNick, $ratingData = array ())

	{

		$this->players[] = new CPlayer ($strNick, $ratingData);

	}





	/**

	 * Get ratings from the Game Patform

	 * @abstract

	 **/

	function getRatings ()

	{

	}

	/**

	 * Proccess the Result of the getRstings ()

	 * @base

	 **/

	function processResult ()

	{

		usort ($this->players, array ($this, "sort"));

	}



	/**

	 * Return the Player at the Index

	 * @param int $index index of the player to be retorned

	 * @return object $this->players[$index]

	 **/

	function getPlayerAt ($index)

	{

		return $this->players[$index];

	}

	/**

	 * Return the Players cuantity added

	 * @return int $count

	 **/

	function playersCount ()

	{

		if ( $this->playerCount == 0 )

		{

			$this->playerCount = count ($this->players);

		}

		return $this->playerCount;

	}



	/**

	 * Funcion parser of the Rating date

	 * @abstract

	 * @return array $parsedData Array with the parsed data elements

	 */

	function parseData ($data)

	{



	}

	function avgToString ()

	{

		$return .= $this->avgInfo['rating'] . '<d>';

		$return .= $this->avgInfo['games'] . '<d>';

		$return .= $this->avgInfo['wins'] . '<d>';

		$return .= $this->avgInfo['losses'] . '<d>';

		$return .= $this->avgInfo['winper'] . '<d>';

		$return .= $this->avgInfo['inc'] . '<d>';

		$return .= $this->avgInfo['streak'] . '<d>';



		return $return;

	}

	function sort ($pElementA, $pElementB)

	{

		if ($pElementA->parsedData['rating'] == $pElementB->parsedData['rating']) return 0;

		return ($pElementA->parsedData['rating'] < $pElementB->parsedData['rating']) ? 1 : -1;



	}

}







/**

 * Voobly Ratings Implement

 **/

class CVooblyLiveRatings extends CLiveRatings

{

    var $ladderId;

    var $key;



    /**

     * Constructor

     **/

    function CVooblyLiveRatings ()

    {

        CLiveRatings::CLiveRatings ();

        $this->ladderId = 8;

        $this->key = VOOBLY_KEY;

    }



    function setLadderId ($id)

    {

        $this->ladderId = $id;

    }

    function getLadderId ()

    {

        return $this->ladderId;

    }



     /**

     * getRatings implement

     * @see CLiveRatings::getRatings ()

     **/

    function cleanUserName ($nick, &$tag)

    {

        $tag = '';

        if ($nick[0] == '[')

        {

            $end = strpos ($nick, ']') + 1;

            $tag = substr ($nick, 0, $end);

            $nick = substr ($nick, $end);

        }

        return $nick;

    }

    function getRatings ()

    {

        $sockets = array ();

        $buffers = array ();



        $host = "www.voobly.com";

        $headersId = "GET /api/finduser/%s?key=%s HTTP/1.0\r\nHost: %s\r\n\r\n";

        $headersRatings = "GET /api/ladder/%d?key=%s&uid=%d HTTP/1.0\r\nHost: %s\r\n\r\n";





        $totalPlayers = $this->playersCount();



		$ini = time ();

        for ($i = 0; $i < $totalPlayers; $i++)

        {

            $this->players[$i]->buffers = '';

            $this->players[$i]->socket = false;

            if ($this->players[$i]->ratingData['id'] > 0)

            {



                continue;

            }



            $strHeaders = sprintf ($headersId, $this->cleanUserName ($this->players[$i]->nick, $this->players[$i]->mTag), $this->key, $host);

            $this->players[$i]->socket = @fsockopen($host, 80, $errNo, $errStr, 5);



            if ($this->players[$i]->socket)

            {

				stream_set_timeout($this->players[$i]->socket, 10);

                @socket_set_blocking ($this->players[$i]->socket, FALSE);

                @fwrite ($this->players[$i]->socket, $strHeaders);

            }

        }

 

		

        $ready = FALSE;



        while (!$ready)

        {

            $ready = TRUE;

            for ($i = 0; $i < $totalPlayers; $i++)

            {

                if ($this->players[$i]->socket && !feof($this->players[$i]->socket))

                {

                    $this->players[$i]->buffers .= fgets ($this->players[$i]->socket, 512);

                    $ready = FALSE;

					 

                }

            }

        }

		

		for ($i = 0; $i < $totalPlayers; $i++)

		{

			if ($this->players[$i]->socket)

			{

				$info = stream_get_meta_data($this->players[$i]->socket);

				if ($info['timed_out'])

				{

					$this->players[$i]->buffers = '';

				}

			}

		}

  

        for ($i = 0; $i < $totalPlayers; $i++)

        {

            @fclose ($this->players[$i]->socket);

            $this->players[$i]->parseId ();

        }





        /** asdfgg **/



        for ($i = 0; $i < $totalPlayers; $i++)

        {

            $this->players[$i]->buffers = '';

            $this->players[$i]->socket = false;



            if (intval ($this->players[$i]->parsedData['id']) <= 0)

            {

                continue;

            }



            $strHeaders = sprintf ($headersRatings, $this->getLadderId (), $this->key, $this->players[$i]->parsedData['id'], $host);



            $this->players[$i]->socket = @fsockopen($host, 80, $errNo, $errStr, 30);

            if ($this->players[$i]->socket)

            {

                @socket_set_blocking ($this->players[$i]->socket, FALSE);

                @fwrite ($this->players[$i]->socket, $strHeaders);

            }

        }



        unset ($this->key);



        $ready = FALSE;

        while (!$ready)

        {

            $ready = TRUE;

            for ($i = 0; $i < $totalPlayers; $i++)

            {

                if ($this->players[$i]->socket && !feof($this->players[$i]->socket))

                {

                    $this->players[$i]->buffers .= fgets ($this->players[$i]->socket, 8192);

                    $ready = FALSE;

                }

            }

        }

        for ($i = 0; $i < $totalPlayers; $i++)

        {

            @fclose ($this->players[$i]->socket);

            $this->players[$i]->parseRatings ();

            $this->players[$i]->ratingData['room_id'] = (($this->getLadderId () == 8) ? 0 : 1);

        }

        $this->processResult ();

    }



     /**

     * processResult implement

     * @see CLiveRatings::processResult ()

     **/

    function processResult ()

    {

        $this->avgInfo['count'] = 0;



        for ($k = 0; $k < $this->playersCount(); $k++ )

        {

            if ($this->players[$k]->parsedData['games'] != 0)

            {

                $this->avgInfo['count'] ++;

                $this->avgInfo['rating'] += $this->players[$k]->parsedData['rating'];

                $this->avgInfo['wins'] += $this->players[$k]->parsedData['wins'];

                $this->avgInfo['losses'] += $this->players[$k]->parsedData['losses'];

                $this->avgInfo['inc'] += intval ($this->players[$k]->parsedData['inc']);

                $this->avgInfo['streak'] += intval ($this->players[$k]->parsedData['streak']);

            }

        }



		CLiveRatings::processResult ();



		$this->avgInfo['winper'] = sprintf ("%.2f", @($this->avgInfo['wins'] / ($this->avgInfo['wins'] + $this->avgInfo['losses']) * 100));

		$this->avgInfo['games'] = sprintf ("%.2f", @(($this->avgInfo['wins'] + $this->avgInfo['losses']) / $this->avgInfo['count']));

		$this->avgInfo['wins'] = sprintf ("%.2f", @($this->avgInfo['wins']/$this->avgInfo['count']));

		$this->avgInfo['rating'] = sprintf ("%.2f", @($this->avgInfo['rating']/$this->avgInfo['count']));

		$this->avgInfo['losses'] = sprintf ("%.2f", @($this->avgInfo['losses']/$this->avgInfo['count']));

		$this->avgInfo['inc'] = sprintf ("%.2f", @($this->avgInfo['inc']/$this->avgInfo['count']));

		$this->avgInfo['streak'] = sprintf ("%.2f", @($this->avgInfo['streak']/$this->avgInfo['count']));



	}

}





 /**

  * CPlayer

  * Base Class of the Player

  **/



class CPlayer

{

	var $nick;

	var $parsedData;

	var $strBuffer;

	var $ratingData;

    var $buffers;



    function parseId ()

    {

        $pos = strpos ($this->buffers, 'uid');

        if ($pos > 0)

        {

            $this->buffers = substr ($this->buffers, $pos);



            $parts = split ("\n", $this->buffers);

            if (strlen ($parts[1]) > 3)

            {

                $parts = split (",", $parts[1]);

                $this->parsedData['id'] = intval ($parts[0]);

            }

        }

        $this->buffers = null;

    }

    function parseRatings ()

    {

        $pos = strpos ($this->buffers, 'rank');

        if ($pos > 0)

        {

            $this->buffers = substr ($this->buffers, $pos);

            $parts = split ("\n", $this->buffers);

            $parts = split (",", $parts[1]);

            if (count ($parts) > 6)

            {

                $this->parsedData = array (

                    'rank' => intval ($parts[0]),

                    'id' => intval ($parts[1]),

                    'nick' => $parts[2],

                    'rating' => intval ($parts[3]),

                    'games' => intval ($parts[4]) + intval ($parts[5]),

                    'winper' =>  sprintf ("%.2f", intval ($parts[4]) / (intval ($parts[4]) + intval ($parts[5])) * 100),

                    'wins' => intval ($parts[4]),

                    'losses' => intval ($parts[5]),

                    'inc' => 0,

                    'streak' => intval ($parts[6])

                );

            }

        }

        $this->buffers = null;

    }

	/**

	 * Constructor

	 * @param string $nick Nick of the player

	 **/

	function CPlayer ($strNick, $ratingData, $zone = FALSE)

	{

		$this->nick = $strNick;

		$this->country = $strCountry;

		$this->countryPath = $strCountryPath;

		$this->parsedData = array (

			'rank' => 0,

			'id' => 0,

			/*'nick' => $this->nick,*/

			'rating' => 1600,

			'games' => 0,

			'winper' => 0,

			'wins' => 0,

			'losses' => 0,

			'inc' => 0,

			'streak' => 0

		);

		if (count ($ratingData) == 0)

		{

			$this->ratingData = $this->parsedData;

		}

		else

		{

			$this->ratingData = $ratingData;

			if ($this->ratingData['rating'] == 0)

			{

				$this->ratingData['rating'] = 1600;

			}

			if ($this->ratingData['games'] != 0)

			{

				$this->ratingData = $this->ratingData;

			}

			$this->parsedData['id'] = $this->ratingData['id'];

		}

	}

	function setCountry ($strCountry)

	{

		$this->parsedData['country'] = $strCountry;

	}



	function toArray ()

	{

		return array (

			/*'Rank' => $this->parsedData['rank'],*/

			'Id' => $this->parsedData['id'],

			/*'Nick' => $this->parsedData['nick'],*/

			'Rating' => $this->parsedData['rating'],

			'Games' => $this->parsedData['games'],

			'Winper' => $this->parsedData['winper'],

			'Wins' => $this->parsedData['wins'],

			'Losses' => $this->parsedData['losses'],

			'Inc' => $this->parsedData['inc'],

			'Streak' => $this->parsedData['streak']

		);

	}

	/**

	 * Set the Rating info of Parsed data

	 * @param array $data Rating info to be saved

	 **/



	function setParsedData ($data)

	{

		if ($data['games'] != 0 || $data['id'] != 0)

		{

			$this->parsedData = $data;

		}

		unset ($this->strBuffer);

	}



	function toString ()

	{

		$string = '';

		if ($this->parsedData['games'] > 0)

		{

			$string .= $this->parsedData['nick'];

		}

		else

		{

			$string .= $this->nick;

		}

		$string .= BREAK_RATING_DATA;

		$string .= $this->parsedData['rating'] . BREAK_RATING_DATA;

		$string .= $this->parsedData['wins'] . BREAK_RATING_DATA;

		$string .= $this->parsedData['losses'] . BREAK_RATING_DATA;

		$string .= $this->parsedData['games'] . BREAK_RATING_DATA;

		$string .= $this->parsedData['winper'] . BREAK_RATING_DATA;

		$string .= $this->parsedData['streak'] . BREAK_RATING_DATA;

		$string .= $this->parsedData['inc'] . BREAK_RATING_DATA;

		$string .= intval ($this->parsedData['id']) . BREAK_RATING_DATA;

		$string .= intval ($this->ratingData['room_id']);



		return $string;

	}

}







?>