<?php

/**

*

* @package phpBB3

* @version $Id$

* @copyright (c) 2005 phpBB Group

* @license http://opensource.org/licenses/gpl-license.php GNU Public License

*

*/



define('IN_PHPBB', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';

$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx); 



// Start session management

$user->session_begin();

$auth->acl($user->data);

$user->setup();





function checkearAuth (&$datos, &$user, $checkAttach = TRUE)

{

	if ( $datos['attach_id'] == 0 && $checkAttach)

	{

		redirect(append_sid("index.php", true));

		exit();

	}

    /*

     *  Group 4 => global mod

     *  Group 5 => admin

     **/

	if ( !($user->data['user_id'] == $datos['poster_id'] || in_array ($user->data['group_id'], array (4, 5))))

	{

		redirect(append_sid("index.php", true));

		exit();

	}

}



require ('recmod/aoc_lang.php');

require ('recmod/RecordedGame.php');



$template->assign_vars ($recgame_lang);



if ($user->data['user_id'] == '-1')

{

	/**

	* Usuario Anonimo tratando de Editar un RecGame @@, no permitido

	**/

	redirect(append_sid("index.$phpEx", true));

	exit();

}



$action = (isset ($_GET['action'])) ? $_GET['action'] : $_POST['action'];



switch ($action)

{

	case "ianalize":

		$sql = "SELECT poster_id, post_msg_id, attach_id, real_filename, physical_filename

				FROM " . ATTACHMENTS_TABLE . " 

				WHERE attach_id = '" . intval ($_POST['id']) . "'";

		

        $result = $db->sql_query($sql);

        

		$datos = $db->sql_fetchrow ($result);

		checkearAuth ($datos, $user);

	

		if (strcasecmp (substr ($datos['real_filename'], strlen ($datos['real_filename']) - 3), 'zip') == 0)

		{

			$template->assign_vars ( array (

				'S_REC_GAME_MSG' => TRUE,

				'ID_ATTACH' => $datos['attach_id'],

				'FILE_NAME' => $datos['real_filename']

			));

			require_once ('recmod/RecordedGameReader.php');

			require_once ('recmod/RecordedGame.php');

			

			if ($_POST['rectype'] == 2)

            {

                $recordGame = new RecordedGamePack ();

            }

            else

            {

			    $recordGame = new RecordedGameNormal ();

            }

			

			$recordGame->CreateGame ('files/' . $datos['physical_filename'], 'map_' . intval ($datos['attach_id']) . '.png');

			$recordGame->saveOnDb ($datos['attach_id'], $db);

			

			

			if ($recordGame->validRecGameInfo)

			{

				$msg = $recgame_lang['L_ANALIZE_SUCCESS'];

				$msg .= '<br /><br /><a href="viewtopic.php?p=' . $datos['post_msg_id'] . '">' . $recgame_lang['L_CLICK_HERE'] . '</a>';



				$template->assign_vars(array(

					'MESSAGE_TITLE' => "Recorded Game - [ Saved Info ]",

					'MESSAGE_TEXT' => $msg

				));

			}

			else

			{

				$msg = $recgame_lang['L_ANALIZE_POST_ERROR'];

				$msg .= '<br /><br /><a href="viewtopic.php?p=' . $datos['post_msg_id'] . '">' . $recgame_lang['L_CLICK_HERE'] . '</a>';



				$template->assign_vars(array(

					'MESSAGE_TITLE' => "Recorded Game - [ Error ]",

					'MESSAGE_TEXT' => $msg

				));			

			}

			unset ($recordGame);

			

		}

		else

		{

  

			$msg = $recgame_lang['L_ANALIZE_ERROR'];

			$msg .= '<br /><br /><a href="viewtopic.php?p=' . $datos['post_msg_id'] . '">' . $recgame_lang['L_CLICK_HERE'] . '</a>';



			$template->assign_vars(array(

				'S_REC_GAME_MSG' => TRUE,

				'MESSAGE_TITLE' => "Recorded Game - [ Error Message ]",

				'MESSAGE_TEXT' => $msg

			));	

		}

		break;

		

	case "analize":

		$sql = "SELECT poster_id, post_msg_id, attach_id, real_filename, physical_filename

				FROM " . ATTACHMENTS_TABLE . " 

				WHERE attach_id = '" . intval ($_GET['id']) . "'";

				

        $result = $db->sql_query($sql);

		

		$datos = $db->sql_fetchrow ($result);

		checkearAuth ($datos, $user);

		

		if (strcasecmp (substr ($datos['real_filename'], strlen ($datos['real_filename']) - 3), 'zip') == 0)

		{

			require_once ('recmod/aoc_lang.php');

			global $aGameData;

			@reset ($aGameData);

			foreach ($aGameData as $key => $value)

			{

				$template->assign_block_vars ('game_type', array (

					'VALUE' => $key,

					'NAME' => $value)

				);

			}	

   

			

			$template->assign_vars ( array (

				'S_REC_GAME_CONFIRM_ANALIZE' => TRUE,

				'ID_ATTACH' => $datos['attach_id'],

				'FILE_NAME' => $datos['real_filename']

			));

		

		}

		else

		{

   

			$msg = $recgame_lang['L_ANALIZE_ERROR'];

			$msg .= '<br /><br /><a href="viewtopic.php?p=' . $datos['post_msg_id'] . '">' . $recgame_lang['L_CLICK_HERE'] . '</a>';

			$msg .= '<br /><br /><a href="posting.php?mode=editpost&p=' . $datos['post_msg_id'] . '">' . $recgame_lang['L_CLICK_BACK'] . '</a>';

			$template->assign_vars(array(

				'S_REC_GAME_MSG' => TRUE,

				'MESSAGE_TITLE' => "Recorded Game - [ Error Message ]",

				'MESSAGE_TEXT' => $msg

			));	

		}

		

		break;

	case "edit":

		$sql = "SELECT a.poster_id, a.post_msg_id, a.attach_id, a.real_filename, a.physical_filename, r.*

				FROM " . ATTACHMENTS_TABLE . " a, " . TABLE_RECGAMES . " r

				WHERE a.attach_id = r.attach_id

				AND a.attach_id = '" . intval ($_GET['id']) . "'";

 

		$result = $db->sql_query($sql);

                              		

		$datos = $db->sql_fetchrow ($result);



		checkearAuth ($datos, $user);

   

		

		if ($datos['Id_Player'] == 0)

		{

			$objRecordGame = new RecordedGameNormal ();

			$objRecordGame->setTemplate ($template);

			$strTemplate = 'S_REC_GAME_NORMAL_EDIT';

			$objRecordGame->showEdit ($datos['attach_id'], $db);

		}

		else

		{

			$objRecordGame = new RecordedGamePack ();

			$objRecordGame->setTemplate ($template);

			$strTemplate = 'S_REC_GAME_PACK_EDIT';

			$objRecordGame->showEdit ($datos['attach_id'], $db, $datos['Id_Player']);

		}

  



		$template->assign_vars ( array (

			$strTemplate => TRUE,

			'TOPIC_ID' => $datos['post_msg_id'],

			'RECGAME_ID' => $datos['Id_RecordedGame']

		));

		break;

	

	case "iedit":

		if ($_POST['create'] > 0)

		{

			$sql = "SELECT poster_id, post_msg_id, attach_id, real_filename, physical_filename

					FROM " . ATTACHMENTS_TABLE . " 

					WHERE attach_id = '" . intval ($_POST['attach_id']) . "'";

   

			$result = $db->sql_query($sql);

			$datos = $db->sql_fetchrow ($result);

			checkearAuth ($datos, $user);



			if ($_POST['create'] == 1)

			{

				$objRecordGame = new RecordedGameNormal ();

				$objRecordGame->createGame ();

				$objRecordGame->saveOnDbInsert ($datos['attach_id'], $db);

			}

			else

			{

				$objRecordGame = new RecordedGamePack ();

				$objRecordGame->createGame ();

				$objRecordGame->saveOnDbInsert ($datos['attach_id'], $db);

			}

 

			$msg = $recgame_lang['L_RECG_CREADO'];

			$msg .= '<br /><br /><a href="viewtopic.php?p=' . $datos['post_msg_id'] . '">' . $recgame_lang['L_CLICK_HERE'] . '</a>';



			$template->assign_vars(array(

				'S_REC_GAME_MSG' => TRUE,

				'MESSAGE_TITLE' => "Recorded Game - [ Add Info ]",

				'MESSAGE_TEXT' => $msg

			));

		}

		else

		{

		$sql = "SELECT a.poster_id, a.post_msg_id, a.attach_id, a.real_filename, a.physical_filename, r.Id_Player, r.Id_RecordedGame

				FROM " . ATTACHMENTS_TABLE . " a, " . TABLE_RECGAMES . " r 

				WHERE  r.attach_id = a.attach_id

				AND r.Id_RecordedGame = '" . intval ($_POST['idrecgame']) . "'";

       

			$result = $db->sql_query($sql);

			$datos = $db->sql_fetchrow ($result);

			checkearAuth ($datos, $user);



			if ($datos['Id_Player'] > 0)

			{

				$objRecordGame = new RecordedGamePack ();

				$objRecordGame->createGame ();

				$objRecordGame->saveOnDbUpdate ($db);

			}

			else

			{

				$objRecordGame = new RecordedGameNormal ();

				$objRecordGame->createGame ();

				$objRecordGame->saveOnDbUpdate ($db);

			}

 

			$msg = $recgame_lang['L_RECG_UPDATED'];

			$msg .= '<br /><br /><a href="viewtopic.php?p=' . $datos['post_msg_id'] . '">' . $recgame_lang['L_CLICK_HERE'] . '</a>';

			

			$template->assign_vars (array (

				'S_REC_GAME_MSG' => TRUE,

				'MESSAGE_TITLE' => "Recorded Game - [ Edit ]",

				'MESSAGE_TEXT' => $msg

			));

		}

		break;

		

	case "delete":

  

		$sql = "SELECT a.poster_id, a.post_msg_id, a.attach_id, a.real_filename, a.physical_filename, r.Id_Player, r.Id_RecordedGame

				FROM " . ATTACHMENTS_TABLE . " a, " . TABLE_RECGAMES . " r

				WHERE a.attach_id = r.attach_id AND a.attach_id = '" . intval ($_GET['id']) . "'";

					

		$result = $db->sql_query($sql);

		$datos = $db->sql_fetchrow ($result);



		checkearAuth ($datos, $user);



		$msg = $recgame_lang['L_CONFIRM_DELETE'];

		$hidden = '<input type="hidden" name="action" value="idelete">';

		$hidden .= '<input type="hidden" name="idrecgame" value="' . $datos['Id_RecordedGame']. '">';

		$template->assign_vars(array(

			'S_REC_GAME_CONFIRM' => TRUE,

			'MESSAGE_TITLE' => "Recorded Game - [ Delete ]",

			'MESSAGE_TEXT' => $msg,

	

			'L_YES' => $lang['Yes'],

			'L_NO' => $lang['No'],

	

			'S_CONFIRM_ACTION' => append_sid("recordedgame.php"),

			'S_HIDDEN_FIELDS' => $hidden)

		);



		break;

		

	case "idelete":

	

		$sql = "SELECT a.poster_id, a.post_msg_id, a.attach_id, a.real_filename, a.physical_filename, r.Id_Player, r.Id_RecordedGame

				FROM " . ATTACHMENTS_TABLE . " a, " . TABLE_RECGAMES . " r

				WHERE  r.attach_id = a.attach_id

				AND r.Id_RecordedGame = '" . intval ($_POST['idrecgame']) . "'";



		$result = $db->sql_query($sql);

		$datos = $db->sql_fetchrow ($result);

		checkearAuth ($datos, $user);

			

		if ($_POST['confirm'])

		{

			$objRecordGame = new RecordedGame ();

			$objRecordGame->deleteInfo ($datos['attach_id']);

  

			$msg = $recgame_lang['L_RECG_DELETED'];

			$msg .= '<br /><br /><a href="viewtopic.php?p=' . $datos['post_msg_id'] . '">' . $recgame_lang['L_CLICK_HERE'] . '</a>';

			

			$template->assign_vars(array(

				'S_REC_GAME_MSG' => TRUE,

				'MESSAGE_TITLE' => "Recorded Game - [ Delete ]",

				'MESSAGE_TEXT' => $msg

			));

		}

		else 

		{

			redirect(append_sid("posting.php?mode=edit&f=1&p=" . $datos['post_msg_id'], true));

			exit();

		}

		break;

	default: break;

}	



//

// Start output of page

//





$page_title = "Recorded Game [ Edit ]";





// output page

page_header($page_title);

//page_header($config['sitename']);



$template->set_filenames(array(

	'body' => 'recs/recgame_edit.html'

));



// SQL + ACP eklenecek

make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));



page_footer();



?>